/*
Copyright (c) 2014 by Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This program contains some code from the BSD kernel, which is copyrighted
by the Regents of the University of California. Their copyright statement
and software license is as follows:

 Copyright (c) 1986, 1988, 1991, 1993
	The Regents of the University of California.  All rights reserved.
 (c) UNIX System Laboratories, Inc.  All or some portions of this file
 are derived from material licensed to the University of California
 by American Telephone and Telegraph Co. or Unix System Laboratories,
 Inc. and are reproduced herein with the permission of UNIX System
 Laboratories, Inc.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met: 
 1. Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
 4. Neither the name of the University nor the names of its contributors
    may be used to endorse or promote products derived from this software
    without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS''
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/
/* Generated by re2c 0.13.5 on Thu Jun 13 02:49:02 2013 */
#line 1 "cmdline.re2c"
#include <stdlib.h>
#include <string.h>
#include "cmdline.h"

char** parse_cmd_line(char *inp,int *err)
{
   int N;
   char **out;
   char *begin,*cursor,*marker;

   out= 0;
   *err= -1;
restart:
   N= 0;
   cursor= inp;

next_token:
   begin= cursor;


#line 24 "<stdout>"
{
	char yych;

	yych = *cursor;
	switch (yych) {
	case 0x00:
	case '#':	goto yy2;
	case 0x01:
	case 0x02:
	case 0x03:
	case 0x04:
	case 0x05:
	case 0x06:
	case 0x07:
	case 0x08:
	case '\t':
	case '\v':
	case '\f':
	case '\r':
	case 0x0E:
	case 0x0F:
	case 0x10:
	case 0x11:
	case 0x12:
	case 0x13:
	case 0x14:
	case 0x15:
	case 0x16:
	case 0x17:
	case 0x18:
	case 0x19:
	case 0x1A:
	case 0x1B:
	case 0x1C:
	case 0x1D:
	case 0x1E:
	case 0x1F:
	case ' ':
	case 0x7F:	goto yy5;
	case '\n':	goto yy4;
	case '"':	goto yy7;
	case '\'':	goto yy9;
	case '\\':	goto yy12;
	default:	goto yy10;
	}
yy2:
	++cursor;
yy3:
#line 27 "cmdline.re2c"
	{ goto done; }
#line 75 "<stdout>"
yy4:
	yych = *++cursor;
	goto yy3;
yy5:
	++cursor;
	yych = *cursor;
	goto yy27;
yy6:
#line 28 "cmdline.re2c"
	{ goto next_token; }
#line 86 "<stdout>"
yy7:
	yych = *(marker = ++cursor);
	switch (yych) {
	case 0x00:
	case '\n':	goto yy8;
	default:	goto yy22;
	}
yy8:
#line 32 "cmdline.re2c"
	{ goto fail; }
#line 97 "<stdout>"
yy9:
	yych = *(marker = ++cursor);
	switch (yych) {
	case 0x00:
	case '\n':	goto yy8;
	default:	goto yy16;
	}
yy10:
	++cursor;
	yych = *cursor;
	goto yy14;
yy11:
#line 31 "cmdline.re2c"
	{ goto record; }
#line 112 "<stdout>"
yy12:
	yych = *++cursor;
	goto yy8;
yy13:
	++cursor;
	yych = *cursor;
yy14:
	switch (yych) {
	case 0x00:
	case 0x01:
	case 0x02:
	case 0x03:
	case 0x04:
	case 0x05:
	case 0x06:
	case 0x07:
	case 0x08:
	case '\t':
	case '\n':
	case '\v':
	case '\f':
	case '\r':
	case 0x0E:
	case 0x0F:
	case 0x10:
	case 0x11:
	case 0x12:
	case 0x13:
	case 0x14:
	case 0x15:
	case 0x16:
	case 0x17:
	case 0x18:
	case 0x19:
	case 0x1A:
	case 0x1B:
	case 0x1C:
	case 0x1D:
	case 0x1E:
	case 0x1F:
	case ' ':
	case '"':
	case '#':
	case '\'':
	case '\\':
	case 0x7F:	goto yy11;
	default:	goto yy13;
	}
yy15:
	++cursor;
	yych = *cursor;
yy16:
	switch (yych) {
	case 0x00:
	case '\n':	goto yy17;
	case '\'':	goto yy19;
	case '\\':	goto yy18;
	default:	goto yy15;
	}
yy17:
	cursor = marker;
	goto yy8;
yy18:
	++cursor;
	yych = *cursor;
	switch (yych) {
	case 0x00:
	case '\n':	goto yy17;
	default:	goto yy15;
	}
yy19:
	++cursor;
#line 30 "cmdline.re2c"
	{ goto record; }
#line 187 "<stdout>"
yy21:
	++cursor;
	yych = *cursor;
yy22:
	switch (yych) {
	case 0x00:
	case '\n':	goto yy17;
	case '"':	goto yy24;
	case '\\':	goto yy23;
	default:	goto yy21;
	}
yy23:
	++cursor;
	yych = *cursor;
	switch (yych) {
	case 0x00:
	case '\n':	goto yy17;
	default:	goto yy21;
	}
yy24:
	++cursor;
#line 29 "cmdline.re2c"
	{ goto record; }
#line 211 "<stdout>"
yy26:
	++cursor;
	yych = *cursor;
yy27:
	switch (yych) {
	case 0x01:
	case 0x02:
	case 0x03:
	case 0x04:
	case 0x05:
	case 0x06:
	case 0x07:
	case 0x08:
	case '\t':
	case '\v':
	case '\f':
	case '\r':
	case 0x0E:
	case 0x0F:
	case 0x10:
	case 0x11:
	case 0x12:
	case 0x13:
	case 0x14:
	case 0x15:
	case 0x16:
	case 0x17:
	case 0x18:
	case 0x19:
	case 0x1A:
	case 0x1B:
	case 0x1C:
	case 0x1D:
	case 0x1E:
	case 0x1F:
	case ' ':
	case 0x7F:	goto yy26;
	default:	goto yy6;
	}
}
#line 33 "cmdline.re2c"


done:
   if (out) { out[N]=0; return out; }
   if (N==0) return 0;
   out= malloc(sizeof(char*)*(N+1));
   goto restart;

record:
   if (out) {
      int L= cursor- begin;
      out[N]= malloc(L+1);
      memcpy(out[N], begin, L);
      out[N][L]= 0;
   } 
   N++;
   goto next_token;
fail:
   *err= begin-inp;
   return 0;
}
